package io.fabric8.kubernetes.api.model.batch.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class CronJobBuilder extends io.fabric8.kubernetes.api.model.batch.v1.CronJobFluentImpl<io.fabric8.kubernetes.api.model.batch.v1.CronJobBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.batch.v1.CronJob,io.fabric8.kubernetes.api.model.batch.v1.CronJobBuilder>{
  public CronJobBuilder() {
    this(false);
  }
  public CronJobBuilder(java.lang.Boolean validationEnabled) {
    this(new CronJob(), validationEnabled);
  }
  public CronJobBuilder(io.fabric8.kubernetes.api.model.batch.v1.CronJobFluent<?> fluent) {
    this(fluent, false);
  }
  public CronJobBuilder(io.fabric8.kubernetes.api.model.batch.v1.CronJobFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new CronJob(), validationEnabled);
  }
  public CronJobBuilder(io.fabric8.kubernetes.api.model.batch.v1.CronJobFluent<?> fluent,io.fabric8.kubernetes.api.model.batch.v1.CronJob instance) {
    this(fluent, instance, false);
  }
  public CronJobBuilder(io.fabric8.kubernetes.api.model.batch.v1.CronJobFluent<?> fluent,io.fabric8.kubernetes.api.model.batch.v1.CronJob instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    fluent.withSpec(instance.getSpec()); 
    fluent.withStatus(instance.getStatus()); 
    this.validationEnabled = validationEnabled; 
  }
  public CronJobBuilder(io.fabric8.kubernetes.api.model.batch.v1.CronJob instance) {
    this(instance,false);
  }
  public CronJobBuilder(io.fabric8.kubernetes.api.model.batch.v1.CronJob instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.withSpec(instance.getSpec()); 
    this.withStatus(instance.getStatus()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.batch.v1.CronJobFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.batch.v1.CronJob build() {
    CronJob buildable = new CronJob(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    CronJobBuilder that = (CronJobBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}