package io.fabric8.kubernetes.api.model.batch.v1;

import io.fabric8.kubernetes.api.model.LabelSelectorBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.kubernetes.api.builder.Nested;
import io.fabric8.kubernetes.api.model.LabelSelector;
import java.lang.String;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.PodTemplateSpec;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.model.PodTemplateSpecBuilder;
import java.lang.Long;
import io.fabric8.kubernetes.api.model.PodTemplateSpecFluent;
import java.lang.Object;
import io.fabric8.kubernetes.api.model.LabelSelectorFluent;
import java.lang.Boolean;
import java.util.Map;

 /**
  * Generated
  */
public interface JobSpecFluent<A extends io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.Long getActiveDeadlineSeconds();
  public A withActiveDeadlineSeconds(java.lang.Long activeDeadlineSeconds);
  public java.lang.Boolean hasActiveDeadlineSeconds();
  public java.lang.Integer getBackoffLimit();
  public A withBackoffLimit(java.lang.Integer backoffLimit);
  public java.lang.Boolean hasBackoffLimit();
  public java.lang.String getCompletionMode();
  public A withCompletionMode(java.lang.String completionMode);
  public java.lang.Boolean hasCompletionMode();
  
  /**
   * Method is deprecated. use withCompletionMode instead.
   */
  @java.lang.Deprecated
  public A withNewCompletionMode(java.lang.String arg0);
  public java.lang.Integer getCompletions();
  public A withCompletions(java.lang.Integer completions);
  public java.lang.Boolean hasCompletions();
  public java.lang.Boolean getManualSelector();
  public A withManualSelector(java.lang.Boolean manualSelector);
  public java.lang.Boolean hasManualSelector();
  public java.lang.Integer getParallelism();
  public A withParallelism(java.lang.Integer parallelism);
  public java.lang.Boolean hasParallelism();
  
  /**
   * This method has been deprecated, please use method buildSelector instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.LabelSelector getSelector();
  public io.fabric8.kubernetes.api.model.LabelSelector buildSelector();
  public A withSelector(io.fabric8.kubernetes.api.model.LabelSelector selector);
  public java.lang.Boolean hasSelector();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.SelectorNested<A> withNewSelector();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.SelectorNested<A> withNewSelectorLike(io.fabric8.kubernetes.api.model.LabelSelector item);
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.SelectorNested<A> editSelector();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.SelectorNested<A> editOrNewSelector();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.SelectorNested<A> editOrNewSelectorLike(io.fabric8.kubernetes.api.model.LabelSelector item);
  public java.lang.Boolean getSuspend();
  public A withSuspend(java.lang.Boolean suspend);
  public java.lang.Boolean hasSuspend();
  
  /**
   * This method has been deprecated, please use method buildTemplate instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.PodTemplateSpec getTemplate();
  public io.fabric8.kubernetes.api.model.PodTemplateSpec buildTemplate();
  public A withTemplate(io.fabric8.kubernetes.api.model.PodTemplateSpec template);
  public java.lang.Boolean hasTemplate();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.TemplateNested<A> withNewTemplate();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.TemplateNested<A> withNewTemplateLike(io.fabric8.kubernetes.api.model.PodTemplateSpec item);
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.TemplateNested<A> editTemplate();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.TemplateNested<A> editOrNewTemplate();
  public io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.TemplateNested<A> editOrNewTemplateLike(io.fabric8.kubernetes.api.model.PodTemplateSpec item);
  public java.lang.Integer getTtlSecondsAfterFinished();
  public A withTtlSecondsAfterFinished(java.lang.Integer ttlSecondsAfterFinished);
  public java.lang.Boolean hasTtlSecondsAfterFinished();
  public interface SelectorNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.LabelSelectorFluent<io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.SelectorNested<N>>{
    public N and();
    public N endSelector();
    
  }
  public interface TemplateNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.PodTemplateSpecFluent<io.fabric8.kubernetes.api.model.batch.v1.JobSpecFluent.TemplateNested<N>>{
    public N and();
    public N endTemplate();
    
  }
  
}