package io.fabric8.kubernetes.api.model.batch.v1beta1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class CronJobSpecBuilder extends io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecFluentImpl<io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpec,io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecBuilder>{
  public CronJobSpecBuilder() {
    this(false);
  }
  public CronJobSpecBuilder(java.lang.Boolean validationEnabled) {
    this(new CronJobSpec(), validationEnabled);
  }
  public CronJobSpecBuilder(io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecFluent<?> fluent) {
    this(fluent, false);
  }
  public CronJobSpecBuilder(io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new CronJobSpec(), validationEnabled);
  }
  public CronJobSpecBuilder(io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecFluent<?> fluent,io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpec instance) {
    this(fluent, instance, false);
  }
  public CronJobSpecBuilder(io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecFluent<?> fluent,io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withConcurrencyPolicy(instance.getConcurrencyPolicy()); 
    fluent.withFailedJobsHistoryLimit(instance.getFailedJobsHistoryLimit()); 
    fluent.withJobTemplate(instance.getJobTemplate()); 
    fluent.withSchedule(instance.getSchedule()); 
    fluent.withStartingDeadlineSeconds(instance.getStartingDeadlineSeconds()); 
    fluent.withSuccessfulJobsHistoryLimit(instance.getSuccessfulJobsHistoryLimit()); 
    fluent.withSuspend(instance.getSuspend()); 
    this.validationEnabled = validationEnabled; 
  }
  public CronJobSpecBuilder(io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpec instance) {
    this(instance,false);
  }
  public CronJobSpecBuilder(io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withConcurrencyPolicy(instance.getConcurrencyPolicy()); 
    this.withFailedJobsHistoryLimit(instance.getFailedJobsHistoryLimit()); 
    this.withJobTemplate(instance.getJobTemplate()); 
    this.withSchedule(instance.getSchedule()); 
    this.withStartingDeadlineSeconds(instance.getStartingDeadlineSeconds()); 
    this.withSuccessfulJobsHistoryLimit(instance.getSuccessfulJobsHistoryLimit()); 
    this.withSuspend(instance.getSuspend()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpecFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.batch.v1beta1.CronJobSpec build() {
    CronJobSpec buildable = new CronJobSpec(fluent.getConcurrencyPolicy(),fluent.getFailedJobsHistoryLimit(),fluent.getJobTemplate(),fluent.getSchedule(),fluent.getStartingDeadlineSeconds(),fluent.getSuccessfulJobsHistoryLimit(),fluent.getSuspend());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    CronJobSpecBuilder that = (CronJobSpecBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}